"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_1 = require("vue");
var utils_1 = require("./utils");
function useConditionWatcher(config) {
    var _conditions = vue_1.reactive(config.conditions);
    var loading = vue_1.ref(false);
    var data = vue_1.ref([]);
    var error = vue_1.ref(null);
    var refresh = vue_1.ref(function () { });
    vue_1.watchEffect(function () {
        var conditions2Object = __assign({}, _conditions);
        var customConditions = {};
        var cloneDeepCondition = JSON.parse(JSON.stringify(conditions2Object));
        if (typeof config.beforeFetch === 'function') {
            customConditions = config.beforeFetch(cloneDeepCondition);
        }
        var validateCustomConditions = Object.keys(customConditions).length !== 0;
        /*
         * if custom conditions has value, just use custom conditions
         * filterNoneValueObject will filter no value like [] , '', null, undefined
         * example. {name: '', items: [], age: 0, tags: null}
         * return result will be {age: 0}
         */
        var finalCondition = utils_1.filterNoneValueObject(validateCustomConditions ? customConditions : conditions2Object);
        var params = utils_1.createParams(finalCondition, config.defaultParams);
        var _a = useFetchData(function () { return config.fetcher(params); }), fetchDataLoading = _a.loading, fetchDataResult = _a.result, fetchDataError = _a.error, fetchData = _a.use;
        refresh.value = fetchData;
        fetchData();
        vue_1.watch([fetchDataResult, fetchDataError, fetchDataLoading], function (values) {
            data.value = values[0];
            error.value = values[1];
            loading.value = values[2];
        });
    });
    return {
        conditions: _conditions,
        loading: loading,
        data: data,
        refresh: refresh,
        error: error,
    };
}
exports.default = useConditionWatcher;
function useFetchData(fetcher) {
    var _this = this;
    var state = vue_1.reactive({
        loading: false,
        error: null,
        result: null,
    });
    var lastPromise;
    var use = function () { return __awaiter(_this, void 0, void 0, function () {
        var promise, result, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    state.error = null;
                    state.loading = true;
                    promise = (lastPromise = fetcher());
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, 4, 5]);
                    return [4 /*yield*/, promise];
                case 2:
                    result = _a.sent();
                    if (lastPromise === promise) {
                        state.result = result;
                    }
                    return [3 /*break*/, 5];
                case 3:
                    e_1 = _a.sent();
                    state.error = e_1;
                    return [3 /*break*/, 5];
                case 4:
                    state.loading = false;
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    }); };
    return __assign(__assign({}, vue_1.toRefs(state)), { use: use });
}
