import { Ref, InjectionKey } from 'vue';
import { ConditionsType } from './types';
declare type FetcherType = (params: ConditionsType) => Promise<any>;
declare type ProvideKeyName<T> = InjectionKey<T> | string;
interface QueryOptions<T> {
    sync?: ProvideKeyName<T>;
    ignore?: string[];
}
interface Config {
    fetcher: FetcherType;
    conditions: ConditionsType;
    defaultParams?: ConditionsType;
    beforeFetch?: (conditions: ConditionsType) => ConditionsType;
}
interface ResultInterface {
    conditions: {
        [x: string]: any;
    };
    loading: Ref<boolean | false>;
    data: Ref<any | null>;
    refresh: Ref<() => void>;
    error: Ref<any | null>;
}
export default function useConditionWatcher<T extends Config, E extends QueryOptions<E>>(config: T, queryOptions?: E): ResultInterface;
export {};
